
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.InputSource;
import org.xml.sax.Attributes;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;

import java.io.InputStream;

public class XmlParserSAXStationVelib  extends DefaultHandler implements XmlParserStationVelibI{
    private Command cmd;
    private InputStream in;

    public XmlParserSAXStationVelib(InputStream in) throws Exception{
        this.in = in;
    }

    @Override
    public void setCommand(Command cmd){
        this.cmd = cmd;
    }

    @Override
    public void parse() throws Exception{
        SAXParserFactory spf = SAXParserFactory.newInstance();
        SAXParser sp = spf.newSAXParser();
        XMLReader xr = sp.getXMLReader();
        xr.setContentHandler(this);
        xr.parse(new InputSource(this.in));
    }

    public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException{
        super.startElement(uri, localName, qName, attributes);
        if(qName.equals("marker")){
            StationVelib station = new StationVelib();
            station.setName(attributes.getValue("name"));
            station.setNumber(Integer.parseInt(attributes.getValue("number")));
            station.setAddress(attributes.getValue("address"));
            station.setFullAddress(attributes.getValue("fullAddress"));
            station.setLatitude(Double.parseDouble(attributes.getValue("lat")));
            station.setLongitude(Double.parseDouble(attributes.getValue("lng")));
            if(attributes.getValue("bonus").equals("1"))
                station.setBonus(true);
            else
                station.setBonus(false);
            station.setOpen(Integer.parseInt(attributes.getValue("open"))>0);
            try{
                cmd.execute(station);
            }catch(NullPointerException exc){
                throw new NullPointerException("setCommand must be called");
            }catch(Exception exc){
                throw new SAXException(exc.getMessage());
            }

        }
    }
}